src/waves/accounts/urls.py
from __future__ import unicode_literals
from django.conf.urls import include, url
from django.views.generic import TemplateView

import waves.views.accounts

urlpatterns = [
    url(r'^activate/complete/$',
        waves.views.accounts.ActivationView.as_view(template_name='accounts/activation_complete.html'),
        name='registration_activation_complete'),
    url(r'^activate/(?P<activation_key>[-:\w]+)/$',
        waves.views.accounts.ActivationView.as_view(),
        name='registration_activate'),
    url(r'^register/$',
        waves.views.accounts.SignUpView.as_view(),
        name='registration_register'),
    url(r'^register/complete/$',
        TemplateView.as_view(template_name='accounts/registration_complete.html'),
        name='registration_complete'),
    url(r'^register/closed/$',
        TemplateView.as_view(template_name='accounts/registration_closed.html'),
        name='registration_disallowed'),
    url(r'^login/$', waves.views.accounts.LoginView.as_view(), name="login"),
    url(r'^logout/$', waves.views.accounts.LogoutView.as_view(), name='logout'),
    url(r'^signup/$', waves.views.accounts.SignUpView.as_view(), name='signup'),
    url(r'^password/change/$', waves.views.accounts.PasswordChangeView.as_view(), name='password-change'),
    url(r'^password/reset/$', waves.views.accounts.PasswordResetView.as_view(), name='password-reset'),
    url(r'^password/reset/done/$', waves.views.accounts.PasswordResetDoneView.as_view(), name='password-reset-done'),
    url(r'^password/reset/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$$',
        waves.views.accounts.PasswordResetConfirmView.as_view(),
        name='password-reset-confirm'),
]

src/waves/profiles/urls.py
from __future__ import unicode_literals
from django.conf.urls import url
import waves.views.profiles

urlpatterns = [
    url(r'^me$', waves.views.profiles.ShowProfile.as_view(), name='show_self'),
    url(r'^me/edit$', waves.views.profiles.EditProfile.as_view(), name='edit_self'),
    url(r'^(?P<slug>[\w\-]+)$', waves.views.profiles.ShowProfile.as_view(),
        name='show'),
]

src/waves/urls/urls.py
from __future__ import unicode_literals

from django.conf.urls import url
from django.conf.urls import include
from waves.views.base import *

urlpatterns = [
    url(r'^$', HomePage.as_view(), name='home'),
    url(r'^accounts/', include('waves.urls.accounts_url')),
    url(r'^api/', include('waves.urls.api_urls')),
    url(r'^admin/', include('waves.urls.back_urls')),
    url(r'^waves/', include('waves.urls.front_urls'))
]

src/waves_services/urls.py
from __future__ import unicode_literals

from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin

urlpatterns = [
    url(r'^', include('waves.urls.urls', namespace='waves')),
    url(r'^nested_admin/', include('nested_admin.urls')),
    url(r'^grappelli/', include('grappelli.urls')),  # grappelli URLS
    url(r'^admin/', include(admin.site.urls)),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/waves/models/services.py
from __future__ import unicode_literals
import logging
import os

from django import forms
from django.db import models, transaction
from mptt.models import MPTTModel, TreeForeignKey
from polymorphic.models import PolymorphicModel

import waves.const
import waves.managers.services as managers
import waves.settings

from waves.models.base import TimeStampable, DescribeAble, OrderAble
from waves.models.profiles import APIProfile
from waves.models.runners import RunnerParam, Runner
from waves.utils import set_api_name
logger = logging.getLogger(__name__)


class ServiceInputFormat(object):
    @staticmethod
    def format_number(number):
        return number

    @staticmethod
    def format_boolean(truevalue, falsevalue):
        return '{}|{}'.format(truevalue, falsevalue)

    @staticmethod
    def format_interval(minimum, maximum):
        return '{}|{}'.format(minimum, maximum)

    @staticmethod
    def format_list(values):
        return ('' + os.linesep).join(values)

    @staticmethod
    def param_type_from_value(value):
        import re
        param_type = waves.const.OPT_TYPE_SIMPLE
        if not value or value == '':
            return param_type
        try:
            """
            (OPT_TYPE_NONE, 'Not used in job submission'),
            (OPT_TYPE_VALUATED, 'Valuated param (--param_name=value)'),
            (OPT_TYPE_SIMPLE, 'Simple param (-param_name value)'),
            (OPT_TYPE_OPTION, 'Option param (-param_name)'),
            (OPT_TYPE_NAMED_OPTION, 'Option named param (--param_name)'),
            (OPT_TYPE_POSIX, 'Positional param (no name)')
            """
            if re.match('--\w+=\w+', value):
                param_type = waves.const.OPT_TYPE_VALUATED
            elif re.match('-\w+ \w+', value):
                param_type = waves.const.OPT_TYPE_SIMPLE
            elif re.match('-{1}\w{1}', value):
                param_type = waves.const.OPT_TYPE_OPTION
            elif re.match('--{1}\w+', value):
                param_type = waves.const.OPT_TYPE_NAMED_OPTION
            else:
                param_type = waves.const.OPT_TYPE_POSIX
            logger.debug("matched %i ", param_type)
        except Exception as e:
            logger.warn("Exception in regexp %s %s", value, e.message)
        return param_type

    @staticmethod
    def choice_list(value):
        list_choice = []
        if value:
            try:
                for param in value.splitlines(False):
                    if '|' in param:
                        val = param.split('|')
                        list_choice.append((val[1], val[0]))
                    else:
                        list_choice.append((param, param))
            except ValueError as e:
                logger.warn('Error Parsing list values %s - value:%s - param:%s', e.message, value, param)
        return list_choice


class ServiceRunnerParam(models.Model):
    class Meta:
        db_table = 'waves_service_runner_param'
        verbose_name = 'Service\'s runner init param'
        unique_together = ('service', 'param')

    service = models.ForeignKey('Service',
                                null=False,
                                related_name='service_run_params',
                                on_delete=models.CASCADE,
                                help_text='Runner init param for this service')
    param = models.ForeignKey(RunnerParam,
                              null=False,
                              on_delete=models.CASCADE,
                              related_name='param_srv',
                              help_text='Initial runner param')
    value = models.CharField('Param value',
                             max_length=255,
                             null=True,
                             blank=True,
                             help_text='Runner init param value for this service')

    def __str__(self):
        return str(self.param.name) + u'[' + str(self.value) + u']'

    def clean(self):
        super(ServiceRunnerParam, self).clean()

    def save(self, *args, **kwargs):
        if not self.value:
            self.value = self.param.default
        super(ServiceRunnerParam, self).save(*args, **kwargs)


class ServiceCategory(MPTTModel, OrderAble, DescribeAble):
    class Meta:
        db_table = 'waves_service_category'
        verbose_name = 'Service\'s category'
        verbose_name_plural = 'Services\' categories'
        unique_together = ('name',)

    class MPTTMeta:
        order_insertion_by = ['name']

    name = models.CharField('Category Name',
                            null=False,
                            blank=False,
                            max_length=255,
                            unique=True,
                            help_text='Category displayed name')
    ref = models.URLField('Reference',
                          null=True,
                          blank=True,
                          help_text='Category description reference')
    api_name = models.CharField(max_length=100, unique=True, null=True, blank=True)
    parent = TreeForeignKey('self', null=True, blank=True, help_text='This is parent category',
                            related_name='children_category', db_index=True)

    def save(self, *args, **kwargs):
        if not self.api_name:
            self.api_name = set_api_name(self.name)
        super(ServiceCategory, self).save(*args, **kwargs)

    def __str__(self):
        return self.name


class Service(TimeStampable, DescribeAble):
    """
    Represents a service on the platform
    """

    class Meta:
        ordering = ['name']
        db_table = 'waves_service'
        verbose_name = 'Service'
        unique_together = ('api_name', 'version', 'status')

    # manager
    objects = managers.ServiceManager()
    # fields
    name = models.CharField('Service name',
                            max_length=255,
                            help_text='Service displayed name')
    api_name = models.CharField('Api name',
                                max_length=50,
                                unique=True,
                                blank=True,
                                help_text='Service API name (for urls)')
    version = models.CharField('Current version',
                               max_length=10,
                               null=True,
                               blank=True,
                               default='1.0',
                               help_text='Service displayed version')
    run_on_version = models.CharField('Runner tool version',
                                      max_length=15,
                                      null=True,
                                      blank=True,
                                      help_text='Remote runner tool version')
    run_on = models.ForeignKey(Runner,
                               related_name='runs',
                               null=True,
                               blank=True,
                               on_delete=models.SET_NULL,
                               help_text='Service job runs adapter')
    runner_params = models.ManyToManyField(RunnerParam,
                                           through=ServiceRunnerParam,
                                           related_name='service_init_params',
                                           help_text='Runner initial parameter')
    restricted_client = models.ManyToManyField(APIProfile,
                                               related_name='restricted_services',
                                               blank=True,
                                               verbose_name='Restricted clients',
                                               db_table='waves_service_client',
                                               help_text='By default access is granted to everyone, '
                                                         'you may restrict access here.')
    clazz = models.CharField('Parser class',
                             null=True,
                             blank=True,
                             max_length=255,
                             help_text='Service job submission command')
    category = models.ForeignKey(ServiceCategory,
                                 on_delete=models.SET_NULL,
                                 null=True,
                                 related_name='category_tools',
                                 help_text='Service category')
    status = models.IntegerField(choices=waves.const.SRV_STATUS_LIST,
                                 default=waves.const.SRV_DRAFT,
                                 help_text='Service online status')
    api_on = models.BooleanField('Available on API',
                                 default=True,
                                 help_text='Service is available for api calls ?')

    email_on = models.BooleanField('Notify results to client',
                                   default=True,
                                   help_text='This service sends notification email')

    # TODO CHANGE THIS TO LIST (Non dynamic, Dynamics, dynamics + redirect output to dir
    partial = models.BooleanField('Dynamic outputs',
                                  default=False,
                                  help_text='Set whether some service outputs are dynamic (not known in advance)')

    def __str__(self):
        return "%s v(%s)" % (self.name, self.version)

    def clean(self):
        # TODO add version number validation
        # TODO add check for mandatory expected params setup (mandatory with no default, not mandatory with default)
        if not self.api_name:
            self.set_api_name()
        super(Service, self).clean()

    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        super(Service, self).save(force_insert, force_update, using, update_fields)
        if self.run_on and self.service_run_params.count() != self.run_on.runner_params.count():

src/waves/api/views/categories.py
from __future__ import unicode_literals

from rest_framework import viewsets

from waves.models import ServiceCategory
from waves.api.serializers import CategorySerializer
from . import WavesBaseView


class CategoryViewSet(viewsets.ReadOnlyModelViewSet, WavesBaseView):
    """
    API entry point to list services categories
    """
    queryset = ServiceCategory.objects.all()
    serializer_class = CategorySerializer
    lookup_field = 'name'

src/waves/api/views/jobs.py
from __future__ import unicode_literals
import logging

from django.shortcuts import get_object_or_404
from rest_framework import viewsets, mixins
from rest_framework.parsers import MultiPartParser, JSONParser
from rest_framework.response import Response
from rest_framework.decorators import detail_route, list_route

from waves.models import Job
from waves.api.serializers.jobs import JobSerializer, JobHistoryDetailSerializer, \
    JobInputDetailSerializer, JobOutputDetailSerializer
from . import WavesBaseView

logger = logging.getLogger(__name__)


class JobViewSet(mixins.ListModelMixin, mixins.RetrieveModelMixin, mixins.DestroyModelMixin,
                 viewsets.GenericViewSet, WavesBaseView):
    """
    API entry point for ServiceJobs
    """
    queryset = Job.objects.all()
    serializer_class = JobSerializer
    parser_classes = (MultiPartParser, JSONParser)
    lookup_field = 'slug'

    def get_queryset(self):
        return Job.objects.all()

    def list(self, request, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        serializer = JobSerializer(queryset,
                                   many=True,
                                   context={'request': request},
                                   fields=('url', 'created', 'status', 'service'))
        return Response(serializer.data)

    def retrieve(self, request, slug=None, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        service_job = get_object_or_404(queryset,
                                        slug=slug)
        serializer = JobSerializer(service_job,
                                   context={'request': request})
        return Response(serializer.data)

    def destroy(self, request, slug=None, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        service_job = get_object_or_404(queryset, slug=slug)
        return Response(self.get_serializer(request=request).data)

    def update(self, request, slug=None):
        return Response(self.get_serializer(request=request).data)

    def partial_update(self, request, slug=None):
        return Response(self.get_serializer(request=request).data)

    @detail_route(methods=['get'], url_path='history')
    def list_history(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobHistoryDetailSerializer(job,
                                                many=False,
                                                context={'request': request})
        return Response(serializer.data)

    @detail_route(methods=['get'], url_path='inputs')
    def list_inputs(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobInputDetailSerializer(job,
                                              many=False,
                                              context={'request': request})
        return Response(serializer.data)

    @detail_route(methods=['get'], url_path='outputs')
    def list_outputs(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobOutputDetailSerializer(job,
                                               many=False,
                                               context={'request': request})
        return Response(serializer.data)

src/waves/views/base.py
from __future__ import unicode_literals
from django.views import generic


class HomePage(generic.TemplateView):
    template_name = "home.html"


class AboutPage(generic.TemplateView):
    template_name = "about.html"

src/waves/templates/services/_service_head.html
<div class="row">
    <div class="col-md-12 text-center">
        <h1><strong>{{ service.name }}</strong> - v{{ service.version }}</h1>
        <p class="text-muted">Online since {{ service.created }} / last update {{ service.updated }}</p>
        <hr/>
    </div>
</div>

src/waves/templates/services/base.html
{% extends 'base.html' %}

{% block navbar-left %}
    {% include "_navbar.html" with active_link="services" %}
{% endblock %}

src/waves/templates/services/job_detail.html
{% extends "services/base.html" %}

{% block container %}
    <div id="sec1">
        <div class="text-page container">
            <div class="row">
                <div class="col-md-8">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <p class="panel-title text-left">
                            <h1>
                                <strong>{{ job.service }} job</strong>
                            </h1>
                            </p>
                            <div class="text-right">
                                <h3><span
                                        class="label label-{{ job.label_class }}">{{ job.get_status_display }}</span>
                                </h3>
                                <p class="text">
                                    <em>
                                    Created on {{ job.created }} <br/>
                                    Last update {{ job.updated }}
                                    </em>
                                </p>
                            </div>
                        </div>
                        <div class="panel-body">
                            <div class="panel-group" id="panel-inout-{{ job.slug }}">
                                <div class="panel panel-default">
                                    <div class="panel-heading">
                                        <a class="panel-title collapsed" data-toggle="collapse"
                                           data-parent="#panel-inout-{{ job.slug }}"
                                           href="#panel-input-{{ job.id }}">Job inputs</a>
                                    </div>
                                    <div id="panel-input-{{ job.id }}" class="panel-collapse">
                                        <div class="panel-body">
                                            <dl>
                                                {% for job_input in job.input_files.all %}
                                                    <dt>
                                                        {{ job_input.label }}</dt>
                                                    <dd class="input_output">
                                                        {{ job_input.value }}
                                                        <div class="pull-right">
                                                            <a href="{% url 'waves:job_input' job_input.slug %}">See
                                                                online</a>
                                                            &nbsp;|&nbsp;
                                                            <a href="{% url 'waves:job_input' job_input.slug %}?export=1">
                                                                Download File <i
                                                                    class="glyphicon glyphicon-download-alt"></i>
                                                            </a>
                                                        </div>
                                                    </dd>
                                                {% endfor %}
                                            </dl>
                                        </div>
                                    </div>
                                </div>
                                <div class="panel panel-default">
                                    <div class="panel-heading">
                                        <a class="panel-title collapsed" data-toggle="collapse"
                                           data-parent="#panel-inout-{{ job.slug }}"
                                           href="#panel-params-{{ job.id }}">Job params</a>
                                    </div>
                                    <div id="panel-params-{{ job.id }}" class="panel-collapse collapse">
                                        <div class="panel-body">
                                            <dl>
                                                {% for job_input in job.input_params.all %}
                                                    <dt>"{{ job_input.label }}" set to</dt>
                                                    <dd class="input_output">
                                                        {% if job_input.type == 'select' %}
                                                            {{ job_input.get_label_for_choice }}
                                                        {% else %}
                                                            {{ job_input.value }}
                                                        {% endif %}
                                                    </dd>
                                                {% endfor %}
                                            </dl>
                                        </div>
                                    </div>
                                </div>
                                <div class="panel panel-default">
                                    <div class="panel-heading">
                                        <a class="panel-title {% if not job.results_available %}collapsed{% endif %}"
                                           data-toggle="collapse"
                                           data-parent="#panel-inout-{{ job.slug }}"
                                           href="#panel-output-{{ job.id }}">Outputs</a>
                                    </div>
                                    <div id="panel-output-{{ job.id }}"
                                         class="panel-collapse {% if not job.results_available %}collapse{% endif %}">
                                        <div class="panel-body">
                                            <dl>
                                                {% for job_output in job.output_files_exists %}
                                                    <dt>{{ job_output.name }}</dt>
                                                    <dd class="input_output">
                                                        {{ job_output.value|default:'Not available' }}
                                                        <div class="pull-right">
                                                            {% if job.results_available and job_output.value %}
                                                                <a href="{% url 'waves:job_output' job_output.slug %}">See
                                                                    online</a>
                                                                &nbsp;|&nbsp;
                                                                <a href="{% url 'waves:job_output' job_output.slug %}?export=1">Download
                                                                    File <i
                                                                            class="glyphicon glyphicon-download-alt"></i></a>
                                                            {% else %}
                                                                <i>Not available yet</i>
                                                            {% endif %}
                                                        </div>
                                                    </dd>
                                                    {% empty %}
                                                    <dt>Not available for now, please wait job completion</dt>
                                                {% endfor %}
                                            </dl>
                                        </div>
                                    </div>
                                </div>
                                <div class="panel panel-default">
                                    <div class="panel-heading">
                                        <a class="panel-title collapsed" data-toggle="collapse"
                                           data-parent="#panel-inout-{{ job.slug }}"
                                           href="#panel-runon-{{ job.id }}">Running configuration</a>
                                    </div>
                                    <div id="panel-runon-{{ job.id }}" class="panel-collapse collapse">
                                        <div class="panel-body">
                                            <p>Your job is currently planned to run on
                                                our {{ job.service.run_on.name }}</p>
                                            <p>{{ job.service.run_on.description|safe }}</p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="panel-footer text-right">
                            {% if job.service.api_on %}
                                <p class="text-right">
                                    This job is available on API calls
                                </p>
                            {% endif %}
                            Last update {{ service.updated }}
                        </div>
                    </div>

                </div>
                <div class="col-md-4 panel-group">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            Job History
                        </div>
                        <div class="panel-body">
                            <div class="panel-group" id="panel-job-{{ job.slug }}">
                                {% for history in job.job_history.all %}
                                    <div class="panel panel-default">
                                        <div class="panel-heading">
                                            <a class="panel-title collapsed" data-toggle="collapse"
                                               data-parent="#panel-job-{{ job.slug }}"
                                               href="#panel-element-{{ history.id }}">{{ history.get_status_display }}
                                                - {{ history.timestamp }}</a>
                                        </div>
                                        <div id="panel-element-{{ history.id }}" class="panel-collapse collapse">
                                            <div class="panel-footer">
                                                {{ history.message|default:'No message' }}
                                            </div>
                                        </div>
                                    </div>
                                {% endfor %}
                            </div>
                        </div>
                    </div>
                    <div class="panel panel-default">
                        <div class="panel-body text-right">
                            <a class="btn btn-primary" disabled="disabled"
                               href="{% url 'waves:job_submission' job.service.id %}">Create a copy</a>
                            <a class="btn btn-primary" href="{% url 'waves:job_submission' job.service.id %}">Create
                                new</a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

src/waves/templates/services/job_list.html
{% extends "services/base.html" %}

{% block container %}
    <div id="sec1" class="text-page">
        <div class="container">
            <div class="row">
                <div class="col-md-12 text-center">
                    <h1><strong>Your jobs</strong></h1>
                </div>
            </div>
        </div><!-- /.container -->
    </div>
    <div id="sec2" class="container">
        <div class="row">
            <div class="col-md-12">
                {% for job in job_list %}
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <h3 class="panel-title ">
                                <span class="label label-{{ job.label_class }}">{{ job.get_status_display }}</span>
                                <a href="{% url 'waves:job_details' job.slug %}">{{ job }}</a>
                            </h3>
                        </div>
                        <div class="panel-body">
                            <ul>
                                <li><em>Created :</em> {{ job.created }}</li>
                                <li><em>Updated :</em> {{ job.updated }}</li>
                            </ul>
                        </div>
                        <div class="panel-footer text-right">
                            <a class="btn btn-primary" disabled="disabled"
                               href="{% url 'waves:job_submission' job.service.id %}">Create a copy</a>
                        </div>
                    </div>
                {% endfor %}
            </div>
        </div>
    </div>
{% endblock %}